"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = polyfill;

var _promise = _interopRequireDefault(require("./promise"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/*global self*/
function polyfill() {
  var local;

  if (typeof global !== 'undefined') {
    local = global;
  } else if (typeof self !== 'undefined') {
    local = self;
  } else {
    try {
      local = Function('return this')();
    } catch (e) {
      throw new Error('polyfill failed because global object is unavailable in this environment');
    }
  }

  var P = local.Promise;

  if (P) {
    var promiseToString = null;

    try {
      promiseToString = Object.prototype.toString.call(P.resolve());
    } catch (e) {// silently ignored
    }

    if (promiseToString === '[object Promise]' && !P.cast) {
      return;
    }
  }

  local.Promise = _promise["default"];
}

module.exports = exports["default"];